## garmin 196 functions
var last_time = 0.0;
var last_bearing = -1;
var tab_chiffres_lettres = ["0","1","2","3","4","5","6","7","8","9","A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"];
var old_status = -1;

var init_variables = func{

	##aircrafts
	props.globals.getNode("/instrumentation/garmin196/params/aircrafts/aircraft[0]/name",1).setValue("AIRCRAFT1");
	props.globals.getNode("/instrumentation/garmin196/params/aircrafts/aircraft[0]/max-speed",1).setIntValue(1);
	props.globals.getNode("/instrumentation/garmin196/params/aircrafts/aircraft[0]/cruise-speed",1).setIntValue(1);
	props.globals.getNode("/instrumentation/garmin196/params/aircrafts/aircraft[0]/fuel-flow",1).setDoubleValue(1);
	props.globals.getNode("/instrumentation/garmin196/params/aircrafts/aircraft[1]/name",1).setValue("AIRCRAFT2");
	props.globals.getNode("/instrumentation/garmin196/params/aircrafts/aircraft[1]/max-speed",1).setIntValue(1);
	props.globals.getNode("/instrumentation/garmin196/params/aircrafts/aircraft[1]/cruise-speed",1).setIntValue(1);
	props.globals.getNode("/instrumentation/garmin196/params/aircrafts/aircraft[1]/fuel-flow",1).setDoubleValue(1);
	props.globals.getNode("/instrumentation/garmin196/params/aircrafts/aircraft[2]/name",1).setValue("AIRCRAFT3");
	props.globals.getNode("/instrumentation/garmin196/params/aircrafts/aircraft[2]/max-speed",1).setIntValue(1);
	props.globals.getNode("/instrumentation/garmin196/params/aircrafts/aircraft[2]/cruise-speed",1).setIntValue(1);
	props.globals.getNode("/instrumentation/garmin196/params/aircrafts/aircraft[2]/fuel-flow",1).setDoubleValue(1);
	props.globals.getNode("/instrumentation/garmin196/params/aircrafts/aircraft[3]/name",1).setValue("AIRCRAFT4");
	props.globals.getNode("/instrumentation/garmin196/params/aircrafts/aircraft[3]/max-speed",1).setIntValue(1);
	props.globals.getNode("/instrumentation/garmin196/params/aircrafts/aircraft[3]/cruise-speed",1).setIntValue(1);
	props.globals.getNode("/instrumentation/garmin196/params/aircrafts/aircraft[3]/fuel-flow",1).setDoubleValue(1);
	props.globals.getNode("/instrumentation/garmin196/params/aircrafts/aircraft[4]/name",1).setValue("AIRCRAFT5");
	props.globals.getNode("/instrumentation/garmin196/params/aircrafts/aircraft[4]/max-speed",1).setIntValue(1);
	props.globals.getNode("/instrumentation/garmin196/params/aircrafts/aircraft[4]/cruise-speed",1).setIntValue(1);
	props.globals.getNode("/instrumentation/garmin196/params/aircrafts/aircraft[4]/fuel-flow",1).setDoubleValue(1);
	props.globals.getNode("/instrumentation/garmin196/params/aircrafts/aircraft[5]/name",1).setValue("AIRCRAFT6");
	props.globals.getNode("/instrumentation/garmin196/params/aircrafts/aircraft[5]/max-speed",1).setIntValue(1);
	props.globals.getNode("/instrumentation/garmin196/params/aircrafts/aircraft[5]/cruise-speed",1).setIntValue(1);
	props.globals.getNode("/instrumentation/garmin196/params/aircrafts/aircraft[5]/fuel-flow",1).setDoubleValue(1);
	props.globals.getNode("/instrumentation/garmin196/menu_aircraft/x_char",1).setIntValue(0);
	props.globals.getNode("/instrumentation/garmin196/menu_aircraft/y_char",1).setIntValue(0);
		
	##load atis freq
	fgcommand("loadxml", props.Node.new({ filename: getprop("/sim/fg-root")~"/Aircraft/Instruments-3d/garmin196/airports_atis.xml", targetnode: "/instrumentation/garmin196" }));
	
	##init waypoint system
	props.globals.getNode("/instrumentation/garmin196/panel-wpt-bearing",1).setDoubleValue(0);
	props.globals.getNode("/instrumentation/garmin196/position-wpt-bearing",1).setDoubleValue(0);
	props.globals.getNode("/instrumentation/garmin196/panel-wpt-id",1).setValue("------");
	props.globals.getNode("/instrumentation/gps/config/drive-autopilot",1).setBoolValue(0); ##pour ne pas interferer avec l'autopilot

	##init map system
	props.globals.getNode("/instrumentation/garmin196/map-range",1).setDoubleValue(0.125);
	
	##init dto system
	props.globals.getNode("/instrumentation/garmin196/dto_display/x_char",1).setIntValue(0);
	props.globals.getNode("/instrumentation/garmin196/dto_display/y_char",1).setIntValue(0);
	
	##init saveable variables
	props.globals.getNode("/instrumentation/garmin196/antenne-deg",1).setDoubleValue(30);
	props.globals.getNode("/instrumentation/garmin196/light",1).setDoubleValue(30);
	props.globals.getNode("/instrumentation/garmin196/max-speed",1).setDoubleValue(175);
	props.globals.getNode("/instrumentation/garmin196/no_aircraft",1).setDoubleValue(0);
	props.globals.getNode("/instrumentation/garmin196/symbols/params/airport",1).setBoolValue(1);
	props.globals.getNode("/instrumentation/garmin196/symbols/params/vor",1).setBoolValue(1);
	props.globals.getNode("/instrumentation/garmin196/symbols/params/ndb",1).setBoolValue(1);
	props.globals.getNode("/instrumentation/garmin196/symbols/params/fix",1).setBoolValue(1);
	props.globals.getNode("/instrumentation/garmin196/symbols/params/twn",1).setBoolValue(1);
	props.globals.getNode("/instrumentation/garmin196/symbols/params/wpt",1).setBoolValue(1);
	
	props.globals.getNode("/instrumentation/garmin196/params/units/distance",1).setIntValue(1);
	props.globals.getNode("/instrumentation/garmin196/params/units/speed",1).setIntValue(1);
	props.globals.getNode("/instrumentation/garmin196/params/units/vert-speed",1).setIntValue(1);
	props.globals.getNode("/instrumentation/garmin196/params/units/altitude",1).setIntValue(1);
	props.globals.getNode("/instrumentation/garmin196/params/units/pressure",1).setIntValue(1);
	props.globals.getNode("/instrumentation/garmin196/params/units/temperature",1).setIntValue(1);
	
	
	props.globals.getNode("/instrumentation/garmin196/version",1).setValue("JeeP v. 07/02/2012");
	
	##status du gps
	#0 eteint
	#1 startup page
	#1x map page
	#2x panel page
	#3x position page
	props.globals.getNode("/instrumentation/garmin196/status",1).setIntValue(0);
	
	##popup windows
	#0 = pas de popup
	#1 = affichage du reglage de la lumiere
	#10,11,12 = dto aviation
	#20 = dto recent
	#30 = dto user
	#40 = nrst airport
	#50 = nrst vor
	#60 = nrst ndb
	#70 = nrst fix
	#80 = nrst cities
	#90 = nrst user
	
	#menus
	#100 = menu gps
	#110 = menu flights
	#120 = menu route
	#130 = menu points
	#140 = menu aircraft
	#150 = menu e6b
	#160 = menu map
	#170 = menu setup
	
	props.globals.getNode("/instrumentation/garmin196/popup_status",1).setIntValue(0);
	
	props.globals.getNode("/instrumentation/garmin196/serviceable",1).setBoolValue(0);
	props.globals.getNode("/instrumentation/garmin196/light",1).setDoubleValue(0);
	
	load_cities();
	main_loop();
}
setlistener("/sim/signals/fdm-initialized",init_variables,0,0);

var load_parameters = func{
	fgcommand("loadxml", props.Node.new({ filename: getprop("/sim/fg-home")~"/aircraft-data/garmin196.xml", targetnode: "/instrumentation/garmin196/save" }));
	
	if(getprop("/instrumentation/garmin196/save/antenne-deg")!=nil){
		setprop("/instrumentation/garmin196/antenne-deg",getprop("/instrumentation/garmin196/save/antenne-deg"));
	}
	if(getprop("/instrumentation/garmin196/save/light")!=nil){
		setprop("/instrumentation/garmin196/light",getprop("/instrumentation/garmin196/save/light"));
	}
	if(getprop("/instrumentation/garmin196/save/max-speed")!=nil){
		setprop("/instrumentation/garmin196/max-speed",getprop("/instrumentation/garmin196/save/max-speed"));
	}
	if(getprop("/instrumentation/garmin196/save/no_aircraft")!=nil){
		setprop("/instrumentation/garmin196/no_aircraft",getprop("/instrumentation/garmin196/save/no_aircraft"));
	}
	if(getprop("/instrumentation/garmin196/save/symbols/params/airport")!=nil){
		setprop("/instrumentation/garmin196/symbols/params/airport",getprop("/instrumentation/garmin196/save/symbols/params/airport"));
	}
	if(getprop("/instrumentation/garmin196/save/symbols/params/vor")!=nil){
		setprop("/instrumentation/garmin196/symbols/params/vor",getprop("/instrumentation/garmin196/save/symbols/params/vor"));
	}
	if(getprop("/instrumentation/garmin196/save/symbols/params/ndb")!=nil){
		setprop("/instrumentation/garmin196/symbols/params/ndb",getprop("/instrumentation/garmin196/save/symbols/params/ndb"));
	}
	if(getprop("/instrumentation/garmin196/save/symbols/params/fix")!=nil){
		setprop("/instrumentation/garmin196/symbols/params/fix",getprop("/instrumentation/garmin196/save/symbols/params/fix"));
	}
	if(getprop("/instrumentation/garmin196/save/symbols/params/twn")!=nil){
		setprop("/instrumentation/garmin196/symbols/params/twn",getprop("/instrumentation/garmin196/save/symbols/params/twn"));
	}
	if(getprop("/instrumentation/garmin196/save/symbols/params/wpt")!=nil){
		setprop("/instrumentation/garmin196/symbols/params/wpt",getprop("/instrumentation/garmin196/save/symbols/params/wpt"));
	}
	
	if(getprop("/instrumentation/garmin196/save/params/units/distance")!=nil){
		setprop("/instrumentation/garmin196/params/units/distance",getprop("/instrumentation/garmin196/save/params/units/distance"));
	}
	if(getprop("/instrumentation/garmin196/save/params/units/speed")!=nil){
		setprop("/instrumentation/garmin196/params/units/speed",getprop("/instrumentation/garmin196/save/params/units/speed"));
	}
	if(getprop("/instrumentation/garmin196/save/params/units/vert-speed")!=nil){
		setprop("/instrumentation/garmin196/params/units/vert-speed",getprop("/instrumentation/garmin196/save/params/units/vert-speed"));
	}
	if(getprop("/instrumentation/garmin196/save/params/units/altitude")!=nil){
		setprop("/instrumentation/garmin196/params/units/altitude",getprop("/instrumentation/garmin196/save/params/units/altitude"));
	}
	if(getprop("/instrumentation/garmin196/save/params/units/pressure")!=nil){
		setprop("/instrumentation/garmin196/params/units/pressure",getprop("/instrumentation/garmin196/save/params/units/pressure"));
	}
	if(getprop("/instrumentation/garmin196/save/params/units/temperature")!=nil){
		setprop("/instrumentation/garmin196/params/units/temperature",getprop("/instrumentation/garmin196/save/params/units/temperature"));
	}

	for(var i=0;i<5;i=i+1){
		if(getprop("/instrumentation/garmin196/save/waypoints/recent/wpt["~i~"]/id")!=nil){
			props.globals.getNode("/instrumentation/garmin196/waypoints/recent/wpt["~i~"]/id",1).setValue(getprop("/instrumentation/garmin196/save/waypoints/recent/wpt["~i~"]/id"));
			props.globals.getNode("/instrumentation/garmin196/waypoints/recent/wpt["~i~"]/type",1).setValue(getprop("/instrumentation/garmin196/save/waypoints/recent/wpt["~i~"]/type"));
		}
	}
	
	for(var i=0;i<6;i=i+1){
		if(getprop("/instrumentation/garmin196/save/params/aircrafts/aircraft["~i~"]/name")!=nil){
			props.globals.getNode("/instrumentation/garmin196/params/aircrafts/aircraft["~i~"]/name",1).setValue(getprop("/instrumentation/garmin196/save/params/aircrafts/aircraft["~i~"]/name"));
			props.globals.getNode("/instrumentation/garmin196/params/aircrafts/aircraft["~i~"]/max-speed",1).setIntValue(getprop("/instrumentation/garmin196/save/params/aircrafts/aircraft["~i~"]/max-speed"));
			props.globals.getNode("/instrumentation/garmin196/params/aircrafts/aircraft["~i~"]/cruise-speed",1).setIntValue(getprop("/instrumentation/garmin196/save/params/aircrafts/aircraft["~i~"]/cruise-speed"));
			props.globals.getNode("/instrumentation/garmin196/params/aircrafts/aircraft["~i~"]/fuel-flow",1).setDoubleValue(getprop("/instrumentation/garmin196/save/params/aircrafts/aircraft["~i~"]/fuel-flow"));
		}
	}
	
	for(var i=0;i<8;i=i+1){
		if(getprop("/instrumentation/garmin196/save/flights/flight["~i~"]/start")!=nil){
			props.globals.getNode("/instrumentation/garmin196/flights/flight["~i~"]/start",1).setValue(getprop("/instrumentation/garmin196/save/flights/flight["~i~"]/start"));
			props.globals.getNode("/instrumentation/garmin196/flights/flight["~i~"]/end",1).setValue(getprop("/instrumentation/garmin196/save/flights/flight["~i~"]/end"));
			props.globals.getNode("/instrumentation/garmin196/flights/flight["~i~"]/date",1).setValue(getprop("/instrumentation/garmin196/save/flights/flight["~i~"]/date"));
			props.globals.getNode("/instrumentation/garmin196/flights/flight["~i~"]/aircraft",1).setValue(getprop("/instrumentation/garmin196/save/flights/flight["~i~"]/aircraft"));
			props.globals.getNode("/instrumentation/garmin196/flights/flight["~i~"]/distance",1).setDoubleValue(getprop("/instrumentation/garmin196/save/flights/flight["~i~"]/distance"));
			props.globals.getNode("/instrumentation/garmin196/flights/flight["~i~"]/duration",1).setDoubleValue(getprop("/instrumentation/garmin196/save/flights/flight["~i~"]/duration"));
		}
	}
}
setlistener("/sim/signals/fdm-initialized",load_parameters);

var save_parameters = func{
		##preparation
		if(getprop("/instrumentation/garmin196/antenne-deg")!=nil){
			props.globals.getNode("/instrumentation/garmin196/save/antenne-deg",1).setDoubleValue(getprop("/instrumentation/garmin196/antenne-deg"));
		}
		if(getprop("/instrumentation/garmin196/light")!=nil){
			props.globals.getNode("/instrumentation/garmin196/save/light",1).setDoubleValue(getprop("/instrumentation/garmin196/light"));
		}
		if(getprop("/instrumentation/garmin196/max-speed")!=nil){
			props.globals.getNode("/instrumentation/garmin196/save/max-speed",1).setDoubleValue(getprop("/instrumentation/garmin196/max-speed"));
		}
		if(getprop("/instrumentation/garmin196/no_aircraft")!=nil){
			props.globals.getNode("/instrumentation/garmin196/save/no_aircraft",1).setDoubleValue(getprop("/instrumentation/garmin196/no_aircraft"));
		}
		props.globals.getNode("/instrumentation/garmin196/save/symbols/params/airport",1).setDoubleValue(getprop("/instrumentation/garmin196/symbols/params/airport"));
		props.globals.getNode("/instrumentation/garmin196/save/symbols/params/vor",1).setBoolValue(getprop("/instrumentation/garmin196/symbols/params/vor"));
		props.globals.getNode("/instrumentation/garmin196/save/symbols/params/ndb",1).setBoolValue(getprop("/instrumentation/garmin196/symbols/params/ndb"));
		props.globals.getNode("/instrumentation/garmin196/save/symbols/params/fix",1).setBoolValue(getprop("/instrumentation/garmin196/symbols/params/fix"));
		props.globals.getNode("/instrumentation/garmin196/save/symbols/params/twn",1).setBoolValue(getprop("/instrumentation/garmin196/symbols/params/twn"));
		props.globals.getNode("/instrumentation/garmin196/save/symbols/params/wpt",1).setBoolValue(getprop("/instrumentation/garmin196/symbols/params/wpt"));
		
		props.globals.getNode("/instrumentation/garmin196/save/params/units/distance",1).setIntValue(getprop("/instrumentation/garmin196/params/units/distance"));
		props.globals.getNode("/instrumentation/garmin196/save/params/units/speed",1).setIntValue(getprop("/instrumentation/garmin196/params/units/speed"));
		props.globals.getNode("/instrumentation/garmin196/save/params/units/vert-speed",1).setIntValue(getprop("/instrumentation/garmin196/params/units/vert-speed"));
		props.globals.getNode("/instrumentation/garmin196/save/params/units/altitude",1).setIntValue(getprop("/instrumentation/garmin196/params/units/altitude"));
		props.globals.getNode("/instrumentation/garmin196/save/params/units/pressure",1).setIntValue(getprop("/instrumentation/garmin196/params/units/pressure"));
		props.globals.getNode("/instrumentation/garmin196/save/params/units/temperature",1).setIntValue(getprop("/instrumentation/garmin196/params/units/temperature"));
	
		for(var i=0;i<5;i=i+1){
			if(getprop("/instrumentation/garmin196/waypoints/recent/wpt["~i~"]/id")!=nil){
				props.globals.getNode("/instrumentation/garmin196/save/waypoints/recent/wpt["~i~"]/id",1).setValue(getprop("/instrumentation/garmin196/waypoints/recent/wpt["~i~"]/id"));
				props.globals.getNode("/instrumentation/garmin196/save/waypoints/recent/wpt["~i~"]/type",1).setValue(getprop("/instrumentation/garmin196/waypoints/recent/wpt["~i~"]/type"));
			}
		}
		for(var i=0;i<6;i=i+1){
			if(getprop("/instrumentation/garmin196/params/aircrafts/aircraft["~i~"]/name")!=nil){
				props.globals.getNode("/instrumentation/garmin196/save/params/aircrafts/aircraft["~i~"]/name",1).setValue(getprop("/instrumentation/garmin196/params/aircrafts/aircraft["~i~"]/name"));
				props.globals.getNode("/instrumentation/garmin196/save/params/aircrafts/aircraft["~i~"]/max-speed",1).setIntValue(getprop("/instrumentation/garmin196/params/aircrafts/aircraft["~i~"]/max-speed"));
				props.globals.getNode("/instrumentation/garmin196/save/params/aircrafts/aircraft["~i~"]/cruise-speed",1).setIntValue(getprop("/instrumentation/garmin196/params/aircrafts/aircraft["~i~"]/cruise-speed"));
				props.globals.getNode("/instrumentation/garmin196/save/params/aircrafts/aircraft["~i~"]/fuel-flow",1).setDoubleValue(getprop("/instrumentation/garmin196/params/aircrafts/aircraft["~i~"]/fuel-flow"));
			}
		}
		for(var i=0;i<8;i=i+1){
			if(getprop("/instrumentation/garmin196/flights/flight["~i~"]/start")!=nil){
				props.globals.getNode("/instrumentation/garmin196/save/flights/flight["~i~"]/start",1).setValue(getprop("/instrumentation/garmin196/flights/flight["~i~"]/start"));
				props.globals.getNode("/instrumentation/garmin196/save/flights/flight["~i~"]/end",1).setValue(getprop("/instrumentation/garmin196/flights/flight["~i~"]/end"));
				props.globals.getNode("/instrumentation/garmin196/save/flights/flight["~i~"]/date",1).setValue(getprop("/instrumentation/garmin196/flights/flight["~i~"]/date"));
				props.globals.getNode("/instrumentation/garmin196/save/flights/flight["~i~"]/aircraft",1).setValue(getprop("/instrumentation/garmin196/flights/flight["~i~"]/aircraft"));
				props.globals.getNode("/instrumentation/garmin196/save/flights/flight["~i~"]/distance",1).setDoubleValue(getprop("/instrumentation/garmin196/flights/flight["~i~"]/distance"));
				props.globals.getNode("/instrumentation/garmin196/save/flights/flight["~i~"]/duration",1).setDoubleValue(getprop("/instrumentation/garmin196/flights/flight["~i~"]/duration"));
			}
		}
		fgcommand("savexml", props.Node.new({ filename: getprop("/sim/fg-home")~"/aircraft-data/garmin196.xml", sourcenode: "/instrumentation/garmin196/save" }));
}

var main_loop = func{
	var time = getprop("/sim/time/elapsed-sec");
    var dt = time - last_time;
    last_time = time;
	
	calcul_turn_rate(dt);
	change_speed_display();
	change_position_wpt_bug();
	update_flight();
	update_e6b_menu();
	settimer(main_loop, 0.3);
}

var nyi = func (x) { gui.popupTip(x ~ ": not yet implemented", 3); }

var power = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	if(x==0){
		if(serviceable==1){
			setprop("/instrumentation/garmin196/serviceable",0);
			setprop("/instrumentation/garmin196/status",0);
			setprop("/instrumentation/garmin196/popup_status",0);
		}else{
			setprop("/instrumentation/garmin196/serviceable",1);
			setprop("/instrumentation/garmin196/status",1);
		}
	}
	
	if(x==1 and serviceable==1){
		setprop("/instrumentation/garmin196/popup_status",1)
	}

}

var in = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	if(serviceable==1){
		if(x==0){
			##traitement des pages
			var status = getprop("/instrumentation/garmin196/status");
			if(status==10){
				var range = getprop("/instrumentation/garmin196/map-range");
				range = range / 2;
				if(range<0.125){
					range = 0.125;
				}
				setprop("/instrumentation/garmin196/map-range",range);
				return;
			}
		}
	}
}

var out = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	if(serviceable==1){
		if(x==0){
			##traitement des pages
			var status = getprop("/instrumentation/garmin196/status");
			if(status==10){
				var range = getprop("/instrumentation/garmin196/map-range");
				range = range * 2;
				if(range>8){
					range = 8;
				}
				setprop("/instrumentation/garmin196/map-range",range);
				return;
			}
		}
	}
}

var page = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	if(serviceable==1){
		if(x==0){
			##traitement des pages
			var status = getprop("/instrumentation/garmin196/status");
			if(status==10){
				setprop("/instrumentation/garmin196/status",20);
				return;
			}
			
			if(status==20){
				setprop("/instrumentation/garmin196/status",30);
				return;
			}
			
			if(status==30){
				setprop("/instrumentation/garmin196/status",10);
				update_map();
				return;
			}
		}
	}
}

var quit = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	if(serviceable==1){
		if(x==0){
			#traitement des popup
			var popup_status = getprop("/instrumentation/garmin196/popup_status");
			if(popup_status==1){
				setprop("/instrumentation/garmin196/popup_status",0);
				save_parameters();
				return;
			}
			if(popup_status>=10 and popup_status<=99){
				setprop("/instrumentation/garmin196/popup_status",0);
				return;
			}
			
			##traitement des pages
			var status = getprop("/instrumentation/garmin196/status");
			if(status==10){
				setprop("/instrumentation/garmin196/status",30);
				return;
			}
			
			if(status==20){
				setprop("/instrumentation/garmin196/status",10);
				update_map();
				return;
			}
			
			if(status==30){
				setprop("/instrumentation/garmin196/status",20);
				return;
			}
			
			if(status==111){
				setprop("/instrumentation/garmin196/status",110);
				setprop("/instrumentation/garmin196/menu_flights/no_ligne_selected",-1);
				return;
			}
			
			if(status==112){
				setprop("/instrumentation/garmin196/status",111);
				return;
			}
			
			##menu aircraft
			if(status==141){
				setprop("/instrumentation/garmin196/status",140);
				setprop("/instrumentation/garmin196/menu_aircraft/no_ligne_selected",-1);
			}
			
			if(status==142){
				setprop("/instrumentation/garmin196/status",141);
				display_list_aircraft();
				return;
			}
			
			if(status==143){
				setprop("/instrumentation/garmin196/status",142);
				return;
			}
			
			if(status==144){
				setprop("/instrumentation/garmin196/status",143);
				return;
			}
			
			if(status==145){
				setprop("/instrumentation/garmin196/status",144);
				return;
			}
			
			##menu map
			if(status==161){
				setprop("/instrumentation/garmin196/status",160);
				setprop("/instrumentation/garmin196/menu_map/no_ligne_selected",-1);
				return;
			}
			
			##menu setup
			if(status==171){
				setprop("/instrumentation/garmin196/status",170);
				setprop("/instrumentation/garmin196/menu_setup/no_ligne_selected",-1);
				return;
			}
			
			if(status>=100 and status <180){
				if(old_status>=10){
					status = old_status;
				}else{
					status = 10;
				}
				setprop("/instrumentation/garmin196/status",status);
				if(status==10){
					update_map();
				}
				return;
			}
		}
	}
}

var enter = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	if(serviceable==1){
		if(x==0){
			#traitement des popup
			var popup_status = getprop("/instrumentation/garmin196/popup_status");
			if(popup_status==1){
				setprop("/instrumentation/garmin196/popup_status",0);
				save_parameters();
				return;
			}
			
			if(popup_status==10){
				setprop("/instrumentation/garmin196/popup_status",11);
				display_dto_search();
				return;
			}
			
			if(popup_status==11){
				if(getprop("/instrumentation/garmin196/dto_display/max_ligne_selected")>=0){
					props.globals.getNode("/instrumentation/garmin196/dto_display/ligne[0]/selected",1).setBoolValue(1);
					setprop("/instrumentation/garmin196/popup_status",12);
					return;
				}
			}
			
			if(popup_status==12){
				setprop("/instrumentation/garmin196/popup_status",0);
				var id = getprop("/instrumentation/garmin196/dto_display/ligne["~getprop("/instrumentation/garmin196/dto_display/no_ligne_selected")~"]/id");
				var type = getprop("/instrumentation/garmin196/dto_display/ligne["~getprop("/instrumentation/garmin196/dto_display/no_ligne_selected")~"]/type");
				affectation_waypoint(id);
				##rolling recents waypoints
				var existe_deja = 0;
				for(var i=0;i<5;i=i+1){
					if(getprop("/instrumentation/garmin196/waypoints/recent/wpt["~i~"]/id")==id){
						existe_deja = 1;
						break;
					}
				}
				if(existe_deja==0){
					for(var i=4;i>0;i=i-1){
						if(getprop("/instrumentation/garmin196/waypoints/recent/wpt["~(i-1)~"]/id")){
							props.globals.getNode("/instrumentation/garmin196/waypoints/recent/wpt["~i~"]/id",1).setValue(getprop("/instrumentation/garmin196/waypoints/recent/wpt["~(i-1)~"]/id"));
							props.globals.getNode("/instrumentation/garmin196/waypoints/recent/wpt["~i~"]/type",1).setValue(getprop("/instrumentation/garmin196/waypoints/recent/wpt["~(i-1)~"]/type"));
						}
					}
					props.globals.getNode("/instrumentation/garmin196/waypoints/recent/wpt[0]/id",1).setValue(id);
					props.globals.getNode("/instrumentation/garmin196/waypoints/recent/wpt[0]/type",1).setValue(type);
					save_parameters();
				}
				return;
			}
			
			if(popup_status==20){
				setprop("/instrumentation/garmin196/popup_status",0);
				var id = getprop("/instrumentation/garmin196/dto_display/ligne["~getprop("/instrumentation/garmin196/dto_display/no_ligne_selected")~"]/id");
				var type = getprop("/instrumentation/garmin196/dto_display/ligne["~getprop("/instrumentation/garmin196/dto_display/no_ligne_selected")~"]/type");
				affectation_waypoint(id);
				return;
			}
			
			if(popup_status>=30 and popup_status<=89){
				setprop("/instrumentation/garmin196/popup_status",0);
				var id = getprop("/instrumentation/garmin196/nrst_display/ligne["~getprop("/instrumentation/garmin196/nrst_display/no_ligne_selected")~"]/id");
				var type = getprop("/instrumentation/garmin196/nrst_display/ligne["~getprop("/instrumentation/garmin196/nrst_display/no_ligne_selected")~"]/type");
				affectation_waypoint(id);
				##rolling recents waypoints
				var existe_deja = 0;
				for(var i=0;i<5;i=i+1){
					if(getprop("/instrumentation/garmin196/waypoints/recent/wpt["~i~"]/id")==id){
						existe_deja = 1;
						break;
					}
				}
				if(existe_deja==0){
					for(var i=4;i>0;i=i-1){
						if(getprop("/instrumentation/garmin196/waypoints/recent/wpt["~(i-1)~"]/id")){
							props.globals.getNode("/instrumentation/garmin196/waypoints/recent/wpt["~i~"]/id",1).setValue(getprop("/instrumentation/garmin196/waypoints/recent/wpt["~(i-1)~"]/id"));
							props.globals.getNode("/instrumentation/garmin196/waypoints/recent/wpt["~i~"]/type",1).setValue(getprop("/instrumentation/garmin196/waypoints/recent/wpt["~(i-1)~"]/type"));
						}
					}
					props.globals.getNode("/instrumentation/garmin196/waypoints/recent/wpt[0]/id",1).setValue(id);
					props.globals.getNode("/instrumentation/garmin196/waypoints/recent/wpt[0]/type",1).setValue(type);
					save_parameters();
				}
				return;
			}
			
			##validation de la startup page
			var status = getprop("/instrumentation/garmin196/status");
			if(status==1){
				setprop("/instrumentation/garmin196/status",10);
				update_map();
				return;
			}
			
			if(status==110){
				if(getprop("/instrumentation/garmin196/menu_flights/max_ligne_selected")>=0){
					setprop("/instrumentation/garmin196/menu_flights/no_ligne_selected",0);
					setprop("/instrumentation/garmin196/status",111);
				}
				return;
			}
			
			if(status==111){
				update_menu_flights_detail();
				setprop("/instrumentation/garmin196/status",112);
				return;
			}
			
			if(status==112){
				setprop("/instrumentation/garmin196/status",111);
				return;
			}
			
			if(status==140){
				setprop("/instrumentation/garmin196/status",141);
				setprop("/instrumentation/garmin196/menu_aircraft/no_ligne_selected",getprop("/instrumentation/garmin196/no_aircraft"));
				display_list_aircraft();
				return;
			}
			
			if(status==141){
				setprop("/instrumentation/garmin196/status",142);
				init_menu_aircraft();
				return;
			}
			
			if(status==142){
				setprop("/instrumentation/garmin196/status",143);
				return;
			}
			
			if(status==143){
				setprop("/instrumentation/garmin196/status",144);
				return;
			}
			
			if(status==144){
				setprop("/instrumentation/garmin196/status",145);
				return;
			}
			
			if(status==145){
				setprop("/instrumentation/garmin196/status",141);
				validate_menu_aircraft();
				display_list_aircraft();
				return;
			}
			
			##menu map
			if(status==160){
				setprop("/instrumentation/garmin196/status",161);
				setprop("/instrumentation/garmin196/menu_map/no_ligne_selected",0);
				return;
			}
			
			if(status==161){
				var no_ligne = getprop("/instrumentation/garmin196/menu_map/no_ligne_selected");
				if(no_ligne==0){
					setprop("/instrumentation/garmin196/symbols/params/airport",(getprop("/instrumentation/garmin196/symbols/params/airport")==1 ? 0 : 1));
				}
				if(no_ligne==1){
					setprop("/instrumentation/garmin196/symbols/params/vor",(getprop("/instrumentation/garmin196/symbols/params/vor")==1 ? 0 : 1));
				}
				if(no_ligne==2){
					setprop("/instrumentation/garmin196/symbols/params/ndb",(getprop("/instrumentation/garmin196/symbols/params/ndb")==1 ? 0 : 1));
				}
				if(no_ligne==3){
					setprop("/instrumentation/garmin196/symbols/params/fix",(getprop("/instrumentation/garmin196/symbols/params/fix")==1 ? 0 : 1));
				}
				if(no_ligne==4){
					setprop("/instrumentation/garmin196/symbols/params/twn",(getprop("/instrumentation/garmin196/symbols/params/twn")==1 ? 0 : 1));
				}
				if(no_ligne==5){
					setprop("/instrumentation/garmin196/symbols/params/wpt",(getprop("/instrumentation/garmin196/symbols/params/wpt")==1 ? 0 : 1));
				}
				save_parameters();
				return;
			}
			
			##menu setup
			if(status==170){
				setprop("/instrumentation/garmin196/status",171);
				setprop("/instrumentation/garmin196/menu_setup/no_ligne_selected",0);
				return;
			}
			
			if(status==171){
				var no_ligne = getprop("/instrumentation/garmin196/menu_setup/no_ligne_selected");
				if(no_ligne==0){
					setprop("/instrumentation/garmin196/params/units/distance",(getprop("/instrumentation/garmin196/params/units/distance")==1 ? 2 : 1));
				}
				if(no_ligne==1){
					setprop("/instrumentation/garmin196/params/units/speed",(getprop("/instrumentation/garmin196/params/units/speed")==1 ? 2 : 1));
				}
				if(no_ligne==2){
					setprop("/instrumentation/garmin196/params/units/vert-speed",(getprop("/instrumentation/garmin196/params/units/vert-speed")==1 ? 2 : 1));
				}
				if(no_ligne==3){
					setprop("/instrumentation/garmin196/params/units/altitude",(getprop("/instrumentation/garmin196/params/units/altitude")==1 ? 2 : 1));
				}
				if(no_ligne==4){
					setprop("/instrumentation/garmin196/params/units/pressure",(getprop("/instrumentation/garmin196/params/units/pressure")==1 ? 2 : 1));
				}
				if(no_ligne==5){
					setprop("/instrumentation/garmin196/params/units/temperature",(getprop("/instrumentation/garmin196/params/units/temperature")==1 ? 2 : 1));
				}
				save_parameters();
				return;
			}
	
		}elsif(x==1){
			#traitement des popup
			var popup_status = getprop("/instrumentation/garmin196/popup_status");
			var status = getprop("/instrumentation/garmin196/status");
			if(popup_status==0){##pas de popup
				if(status>=10 and status<=39){
					nyi("mark position");
				}
			}
		}
	}
}

var menu = func (x){
    var serviceable = getprop("/instrumentation/garmin196/serviceable");
	var status = getprop("/instrumentation/garmin196/status");
	if(serviceable==1){
		if(status>=10 and status<100){
			old_status = status;
			setprop("/instrumentation/garmin196/status",100);
			setprop("/instrumentation/garmin196/popup_status",0);
			
			##particularite map
			if(status==10){	
				setprop("/instrumentation/garmin196/status",160);
				setprop("/instrumentation/garmin196/menu_map/no_ligne_selected",-1);
			}
		}elsif(status>=100){
			if(old_status>=10){
				status = old_status;
			}else{
				status = 10;
			}
			setprop("/instrumentation/garmin196/status",status);
		}
	}
}

var nrst = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	var status = getprop("/instrumentation/garmin196/status");
	if(serviceable==1 and status>1 and status<100){
		if(x==0){
			setprop("/instrumentation/garmin196/popup_status",40);
			display_nrst("airport");
		}
	}
}

var dto = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	var status = getprop("/instrumentation/garmin196/status");
	if(serviceable==1 and status>1 and status<100){
		if(x==0){
			setprop("/instrumentation/garmin196/popup_status",10);
			setprop("/instrumentation/garmin196/dto_display/ligne_select","Press Enter to search");
			init_dto_display();
			setprop("/instrumentation/garmin196/dto_display/x_char",0);
			setprop("/instrumentation/garmin196/dto_display/y_char",0);
		}
	}
}

var rockerup = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	if(serviceable==1){
		if(x==0){
			#traitement des popup
			var popup_status = getprop("/instrumentation/garmin196/popup_status");
			
			if(popup_status==1){
				var light_level = getprop("/instrumentation/garmin196/light");
				light_level = light_level + 0.1;
				if(light_level>1){
					light_level = 1;
				}
				setprop("/instrumentation/garmin196/light",light_level);
				return;
			}
			
			if(popup_status==11){
				var y_char = getprop("/instrumentation/garmin196/dto_display/y_char");
				y_char = y_char + 1;
				if(y_char>35){
					y_char = 0;
				}
				setprop("/instrumentation/garmin196/dto_display/y_char",y_char);
				display_dto_search();
				return;
			}
			
			if(popup_status==12){
				var no_ligne = getprop("/instrumentation/garmin196/dto_display/no_ligne_selected");
				var old_no_ligne = no_ligne;
				no_ligne = no_ligne - 1;
				if(no_ligne<0){
					no_ligne = 0;
				}
				setprop("/instrumentation/garmin196/dto_display/no_ligne_selected",no_ligne);
				if(old_no_ligne!=no_ligne){
					setprop("/instrumentation/garmin196/dto_display/ligne["~no_ligne~"]/selected",1);
					setprop("/instrumentation/garmin196/dto_display/ligne["~old_no_ligne~"]/selected",0);
				}
				return;
			}
			
			if(popup_status==20){
				var no_ligne = getprop("/instrumentation/garmin196/dto_display/no_ligne_selected");
				var old_no_ligne = no_ligne;
				no_ligne = no_ligne - 1;
				if(no_ligne<0){
					no_ligne = 0;
				}
				setprop("/instrumentation/garmin196/dto_display/no_ligne_selected",no_ligne);
				setprop("/instrumentation/garmin196/dto_display/ligne_select",getprop("/instrumentation/garmin196/dto_display/ligne["~no_ligne~"]/texte"));
				if(old_no_ligne!=no_ligne){
					setprop("/instrumentation/garmin196/dto_display/ligne["~no_ligne~"]/selected",1);
					setprop("/instrumentation/garmin196/dto_display/ligne["~old_no_ligne~"]/selected",0);
				}
				return;
			}
			
			if(popup_status>=40 and popup_status<=99){
				var no_ligne = getprop("/instrumentation/garmin196/nrst_display/no_ligne_selected");
				var old_no_ligne = no_ligne;
				no_ligne = no_ligne - 1;
				if(no_ligne<0){
					no_ligne = 0;
				}
				setprop("/instrumentation/garmin196/nrst_display/no_ligne_selected",no_ligne);
				setprop("/instrumentation/garmin196/nrst_display/ligne_select",getprop("/instrumentation/garmin196/nrst_display/ligne["~no_ligne~"]/texte"));
				if(old_no_ligne!=no_ligne){
					setprop("/instrumentation/garmin196/nrst_display/ligne["~no_ligne~"]/selected",1);
					setprop("/instrumentation/garmin196/nrst_display/ligne["~old_no_ligne~"]/selected",0);
				}
				return;
			}
			
			##traitement des menus
			var status = getprop("/instrumentation/garmin196/status");
			if(status>=100 and status<110){
				setprop("/instrumentation/garmin196/status",170);
				return;
			}
			
			if(status==110){
				setprop("/instrumentation/garmin196/status",100);
				return;
			}
			
			if(status==111){
				if(getprop("/instrumentation/garmin196/menu_flights/max_ligne_selected")>=0){
					var no_ligne = getprop("/instrumentation/garmin196/menu_flights/no_ligne_selected");
					no_ligne = no_ligne - 1;
					if(no_ligne<0){
						no_ligne = 0;
					}
					setprop("/instrumentation/garmin196/menu_flights/no_ligne_selected",no_ligne);
				}
			}
			
			if(status>=120 and status<130){
				setprop("/instrumentation/garmin196/status",110);
				display_menu_flights();
				return;
			}
			
			if(status>=130 and status<140){
				setprop("/instrumentation/garmin196/status",120);
				return;
			}
			
			if(status==140){
				setprop("/instrumentation/garmin196/status",130);
				return;
			}
			
			if(status==141){
				var no_ligne = getprop("/instrumentation/garmin196/menu_aircraft/no_ligne_selected");
				no_ligne = no_ligne - 1;
				if(no_ligne<0){
					no_ligne = 0;
				}
				setprop("/instrumentation/garmin196/menu_aircraft/no_ligne_selected",no_ligne);
				display_list_aircraft();
				return;
			}
			
			if(status==142){
				var y_char = getprop("/instrumentation/garmin196/menu_aircraft/y_char");
				y_char = y_char + 1;
				if(y_char>35){
					y_char = 0;
				}
				setprop("/instrumentation/garmin196/menu_aircraft/y_char",y_char);
				display_menu_aircraft_name();
				return;
			}
			
			if(status==143){
				var cruise = getprop("/instrumentation/garmin196/menu_aircraft/selected-cruise");
				cruise = cruise + 1;
				if(cruise>500){
					cruise = 500;
				}
				setprop("/instrumentation/garmin196/menu_aircraft/selected-cruise",cruise);
				display_menu_aircraft();
				return;
			}
			
			if(status==144){
				var max = getprop("/instrumentation/garmin196/menu_aircraft/selected-max");
				max = max + 1;
				if(max>500){
					max = 500;
				}
				setprop("/instrumentation/garmin196/menu_aircraft/selected-max",max);
				display_menu_aircraft();
				return;
			}
			
			if(status==145){
				var fuelflow = getprop("/instrumentation/garmin196/menu_aircraft/selected-fuelflow");
				fuelflow = fuelflow + 0.1;
				if(fuelflow>100){
					fuelflow = 100;
				}
				setprop("/instrumentation/garmin196/menu_aircraft/selected-fuelflow",fuelflow);
				return;
			}
	
			if(status==150){
				setprop("/instrumentation/garmin196/status",140);
				setprop("/instrumentation/garmin196/menu_aircraft/no_ligne_selected",-1);
				return;
			}
			
			if(status==160){
				setprop("/instrumentation/garmin196/status",150);
				return;
			}
			
			if(status==161){
				var no_ligne = getprop("/instrumentation/garmin196/menu_map/no_ligne_selected");
				no_ligne = no_ligne - 1;
				if(no_ligne<0){
					no_ligne = 0;
				}
				setprop("/instrumentation/garmin196/menu_map/no_ligne_selected",no_ligne);
				return;
			}
			
			if(status==170){
				setprop("/instrumentation/garmin196/status",160);
				setprop("/instrumentation/garmin196/menu_map/no_ligne_selected",-1);
				return;
			}
			
			if(status==171){
				var no_ligne = getprop("/instrumentation/garmin196/menu_setup/no_ligne_selected");
				no_ligne = no_ligne - 1;
				if(no_ligne<0){
					no_ligne = 0;
				}
				setprop("/instrumentation/garmin196/menu_setup/no_ligne_selected",no_ligne);
				return;
			}

			
		}elsif(x==1){
			#traitement des popup
			var popup_status = getprop("/instrumentation/garmin196/popup_status");
			if(popup_status==11){
				var y_char = getprop("/instrumentation/garmin196/dto_display/y_char");
				y_char = y_char + 10;
				if(y_char>35){
					y_char = y_char-36;
				}
				setprop("/instrumentation/garmin196/dto_display/y_char",y_char);
				display_dto_search();
				return;
			}
			
			##traitement des menus
			var status = getprop("/instrumentation/garmin196/status");
			
			if(status==142){
				var y_char = getprop("/instrumentation/garmin196/menu_aircraft/y_char");
				y_char = y_char + 10;
				if(y_char>35){
					y_char = y_char-36;
				}
				setprop("/instrumentation/garmin196/menu_aircraft/y_char",y_char);
				display_menu_aircraft_name();
				return;
			}
			
			if(status==143){
				var cruise = getprop("/instrumentation/garmin196/menu_aircraft/selected-cruise");
				cruise = cruise + 10;
				if(cruise>500){
					cruise = 500;
				}
				setprop("/instrumentation/garmin196/menu_aircraft/selected-cruise",cruise);
				display_menu_aircraft();
				return;
			}
			
			if(status==144){
				var max = getprop("/instrumentation/garmin196/menu_aircraft/selected-max");
				max = max + 10;
				if(max>500){
					max = 500;
				}
				setprop("/instrumentation/garmin196/menu_aircraft/selected-max",max);
				display_menu_aircraft();
				return;
			}
			
			if(status==145){
				var fuelflow = getprop("/instrumentation/garmin196/menu_aircraft/selected-fuelflow");
				fuelflow = fuelflow + 1;
				if(fuelflow>100){
					fuelflow = 100;
				}
				setprop("/instrumentation/garmin196/menu_aircraft/selected-fuelflow",fuelflow);
				return;
			}
		}
	}
}

var rockerdown = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	if(serviceable==1){
		if(x==0){
			#traitement des popup
			var popup_status = getprop("/instrumentation/garmin196/popup_status");
			if(popup_status==1){
				var light_level = getprop("/instrumentation/garmin196/light");
				light_level = light_level - 0.1;
				if(light_level<0){
					light_level = 0;
				}
				setprop("/instrumentation/garmin196/light",light_level);
				return;
			}
			
			if(popup_status==11){
				var y_char = getprop("/instrumentation/garmin196/dto_display/y_char");
				y_char = y_char - 1;
				if(y_char<0){
					y_char = 35;
				}
				setprop("/instrumentation/garmin196/dto_display/y_char",y_char);
				display_dto_search();
				return;
			}
			
			if(popup_status==12){
				var no_ligne = getprop("/instrumentation/garmin196/dto_display/no_ligne_selected");
				var old_no_ligne = no_ligne;
				var max_ligne = getprop("/instrumentation/garmin196/dto_display/max_ligne_selected");
				no_ligne = no_ligne + 1;
				if(no_ligne>max_ligne){
					no_ligne = max_ligne;
				}
				setprop("/instrumentation/garmin196/dto_display/no_ligne_selected",no_ligne);
				if(old_no_ligne!=no_ligne){
					setprop("/instrumentation/garmin196/dto_display/ligne["~no_ligne~"]/selected",1);
					setprop("/instrumentation/garmin196/dto_display/ligne["~old_no_ligne~"]/selected",0);
				}
				return;
			}
			
			if(popup_status==20){
				var no_ligne = getprop("/instrumentation/garmin196/dto_display/no_ligne_selected");
				var old_no_ligne = no_ligne;
				var max_ligne = getprop("/instrumentation/garmin196/dto_display/max_ligne_selected");
				no_ligne = no_ligne + 1;
				if(no_ligne>max_ligne){
					no_ligne = max_ligne;
				}
				setprop("/instrumentation/garmin196/dto_display/no_ligne_selected",no_ligne);
				setprop("/instrumentation/garmin196/dto_display/ligne_select",getprop("/instrumentation/garmin196/dto_display/ligne["~no_ligne~"]/texte"));
				if(old_no_ligne!=no_ligne){
					setprop("/instrumentation/garmin196/dto_display/ligne["~no_ligne~"]/selected",1);
					setprop("/instrumentation/garmin196/dto_display/ligne["~old_no_ligne~"]/selected",0);
				}
				return;
			}
			
			if(popup_status>=40 and popup_status<=99){
				var no_ligne = getprop("/instrumentation/garmin196/nrst_display/no_ligne_selected");
				var old_no_ligne = no_ligne;
				var max_ligne = getprop("/instrumentation/garmin196/nrst_display/max_ligne_selected");
				no_ligne = no_ligne + 1;
				if(no_ligne>max_ligne){
					no_ligne = max_ligne;
				}
				setprop("/instrumentation/garmin196/nrst_display/no_ligne_selected",no_ligne);
				setprop("/instrumentation/garmin196/nrst_display/ligne_select",getprop("/instrumentation/garmin196/nrst_display/ligne["~no_ligne~"]/texte"));
				if(old_no_ligne!=no_ligne){
					setprop("/instrumentation/garmin196/nrst_display/ligne["~no_ligne~"]/selected",1);
					setprop("/instrumentation/garmin196/nrst_display/ligne["~old_no_ligne~"]/selected",0);
				}
				return;
			}
			
			##traitement des menus
			var status = getprop("/instrumentation/garmin196/status");
			if(status>=100 and status<110){
				setprop("/instrumentation/garmin196/status",110);
				display_menu_flights();
				return;
			}
			
			if(status==110){
				setprop("/instrumentation/garmin196/status",120);
				return;
			}
			
			if(status==111){
				if(getprop("/instrumentation/garmin196/menu_flights/max_ligne_selected")>=0){
					var no_ligne = getprop("/instrumentation/garmin196/menu_flights/no_ligne_selected");
					no_ligne = no_ligne + 1;
					if(no_ligne>getprop("/instrumentation/garmin196/menu_flights/max_ligne_selected")){
						no_ligne = getprop("/instrumentation/garmin196/menu_flights/max_ligne_selected");
					}
					setprop("/instrumentation/garmin196/menu_flights/no_ligne_selected",no_ligne);
				}
				return;
			}
			
			if(status>=120 and status<130){
				setprop("/instrumentation/garmin196/status",130);
				return;
			}
			
			if(status>=130 and status<140){
				setprop("/instrumentation/garmin196/status",140);
				setprop("/instrumentation/garmin196/menu_aircraft/no_ligne_selected",-1);
				return;
			}
			
			if(status==140){
				setprop("/instrumentation/garmin196/status",150);
				return;
			}
			
			if(status==141){
				var no_ligne = getprop("/instrumentation/garmin196/menu_aircraft/no_ligne_selected");
				no_ligne = no_ligne + 1;
				if(no_ligne>5){
					no_ligne = 5;
				}
				setprop("/instrumentation/garmin196/menu_aircraft/no_ligne_selected",no_ligne);
				display_list_aircraft();
				return;
			}
			
			if(status==142){
				var y_char = getprop("/instrumentation/garmin196/menu_aircraft/y_char");
				y_char = y_char - 1;
				if(y_char<0){
					y_char = 35;
				}
				setprop("/instrumentation/garmin196/menu_aircraft/y_char",y_char);
				display_menu_aircraft_name();
				return;
			}
			
			if(status==143){
				var cruise = getprop("/instrumentation/garmin196/menu_aircraft/selected-cruise");
				cruise = cruise - 1;
				if(cruise<1){
					cruise = 1;
				}
				setprop("/instrumentation/garmin196/menu_aircraft/selected-cruise",cruise);
				display_menu_aircraft();
				return;
			}
			
			if(status==144){
				var max = getprop("/instrumentation/garmin196/menu_aircraft/selected-max");
				max = max - 1;
				if(max<1){
					max = 1;
				}
				setprop("/instrumentation/garmin196/menu_aircraft/selected-max",max);
				display_menu_aircraft();
				return;
			}
			
			if(status==145){
				var fuelflow = getprop("/instrumentation/garmin196/menu_aircraft/selected-fuelflow");
				fuelflow = fuelflow - 0.1;
				if(fuelflow<1){
					fuelflow = 1;
				}
				setprop("/instrumentation/garmin196/menu_aircraft/selected-fuelflow",fuelflow);
				return;
			}
			
			if(status==150){
				setprop("/instrumentation/garmin196/status",160);
				setprop("/instrumentation/garmin196/menu_map/no_ligne_selected",-1);
				return;
			}
			
			if(status==160){
				setprop("/instrumentation/garmin196/status",170);
				return;
			}
			
			if(status==161){
				var no_ligne = getprop("/instrumentation/garmin196/menu_map/no_ligne_selected");
				no_ligne = no_ligne + 1;
				if(no_ligne>5){
					no_ligne = 5;
				}
				setprop("/instrumentation/garmin196/menu_map/no_ligne_selected",no_ligne);
				return;
			}
			
			if(status==170){
				setprop("/instrumentation/garmin196/status",100);
				return;
			}
			
			if(status==171){
				var no_ligne = getprop("/instrumentation/garmin196/menu_setup/no_ligne_selected");
				no_ligne = no_ligne + 1;
				if(no_ligne>5){
					no_ligne = 5;
				}
				setprop("/instrumentation/garmin196/menu_setup/no_ligne_selected",no_ligne);
				return;
			}
			
		}elsif(x==1){
			#traitement des popup
			var popup_status = getprop("/instrumentation/garmin196/popup_status");
			if(popup_status==11){
				var y_char = getprop("/instrumentation/garmin196/dto_display/y_char");
				y_char = y_char - 10;
				if(y_char<0){
					y_char = y_char + 36;
				}
				setprop("/instrumentation/garmin196/dto_display/y_char",y_char);
				display_dto_search();
				return;
			}
			
			##traitement des menus
			var status = getprop("/instrumentation/garmin196/status");
			
			if(status==142){
				var y_char = getprop("/instrumentation/garmin196/menu_aircraft/y_char");
				y_char = y_char - 10;
				if(y_char<0){
					y_char = y_char + 36;
				}
				setprop("/instrumentation/garmin196/menu_aircraft/y_char",y_char);
				display_menu_aircraft_name();
				return;
			}
			
			if(status==143){
				var cruise = getprop("/instrumentation/garmin196/menu_aircraft/selected-cruise");
				cruise = cruise - 10;
				if(cruise<1){
					cruise = 1;
				}
				setprop("/instrumentation/garmin196/menu_aircraft/selected-cruise",cruise);
				display_menu_aircraft();
				return;
			}
			
			if(status==144){
				var max = getprop("/instrumentation/garmin196/menu_aircraft/selected-max");
				max = max - 10;
				if(max<1){
					max = 1;
				}
				setprop("/instrumentation/garmin196/menu_aircraft/selected-max",max);
				display_menu_aircraft();
				return;
			}
			
			if(status==145){
				var fuelflow = getprop("/instrumentation/garmin196/menu_aircraft/selected-fuelflow");
				fuelflow = fuelflow - 1;
				if(fuelflow<1){
					fuelflow = 1;
				}
				setprop("/instrumentation/garmin196/menu_aircraft/selected-fuelflow",fuelflow);
				return;
			}
		}
	}
}

var rockerleft = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	if(serviceable==1){
		if(x==0){
			#traitement des popup
			var popup_status = getprop("/instrumentation/garmin196/popup_status");
			if(popup_status==10){
				setprop("/instrumentation/garmin196/popup_status",30);
				return;
			}
			if(popup_status==11){
				var x_char = getprop("/instrumentation/garmin196/dto_display/x_char");
				if(x_char>0){
					setprop("/instrumentation/garmin196/dto_display/x_char",x_char-1);
					setprop("/instrumentation/garmin196/dto_display/y_char",searchLastChar(getprop("/instrumentation/garmin196/dto_display/ligne_select"),getprop("/instrumentation/garmin196/dto_display/x_char")));
					display_dto_search();
				}
				return;
			}
			if(popup_status==20){
				setprop("/instrumentation/garmin196/popup_status",10);
				setprop("/instrumentation/garmin196/dto_display/x_char",0);
				setprop("/instrumentation/garmin196/dto_display/y_char",0);
				setprop("/instrumentation/garmin196/dto_display/ligne_select","Press Enter to search");
				init_dto_display();
				return;
			}
			if(popup_status==30){
				setprop("/instrumentation/garmin196/popup_status",20);
				setprop("/instrumentation/garmin196/dto_display/ligne_select","");
				init_dto_display();
				display_dto_recent();
				return;
			}
			
			if(popup_status==40){
				setprop("/instrumentation/garmin196/popup_status",90);
				display_nrst("user");
				return;
			}
			
			if(popup_status==50){
				setprop("/instrumentation/garmin196/popup_status",40);
				display_nrst("airport");
				return;
			}
			
			if(popup_status==60){
				setprop("/instrumentation/garmin196/popup_status",50);
				display_nrst("vor");
				return;
			}
			
			if(popup_status==70){
				setprop("/instrumentation/garmin196/popup_status",60);
				display_nrst("ndb");
				return;
			}
			
			if(popup_status==80){
				setprop("/instrumentation/garmin196/popup_status",70);
				display_nrst("fix");
				return;
			}
			
			if(popup_status==90){
				setprop("/instrumentation/garmin196/popup_status",80);
				display_nrst("wpt");
				return;
			}
			
			var status = getprop("/instrumentation/garmin196/status");
			
			if(status==111){
				setprop("/instrumentation/garmin196/status",110);
				setprop("/instrumentation/garmin196/menu_flights/no_ligne_selected",-1);
				return;
			}
			
			##menu aircraft
			if(status==141){
				setprop("/instrumentation/garmin196/status",140);
				setprop("/instrumentation/garmin196/menu_aircraft/no_ligne_selected",-1);
				display_list_aircraft();
				return;
			}
			
			if(status==142){
				var x_char = getprop("/instrumentation/garmin196/menu_aircraft/x_char");
				if(x_char>0){
					setprop("/instrumentation/garmin196/menu_aircraft/x_char",x_char-1);
					setprop("/instrumentation/garmin196/menu_aircraft/y_char",searchLastChar(getprop("/instrumentation/garmin196/menu_aircraft/selected-name"),getprop("/instrumentation/garmin196/menu_aircraft/x_char")));
					display_menu_aircraft_name();
				}
				return;
			}
			
			##menu map
			if(status==161){
				setprop("/instrumentation/garmin196/status",160);
				setprop("/instrumentation/garmin196/menu_map/no_ligne_selected",-1);
				return;
			}

			##menu setup
			if(status==171){
				setprop("/instrumentation/garmin196/status",170);
				setprop("/instrumentation/garmin196/menu_setup/no_ligne_selected",-1);
				return;
			}
			
		}
	}
}

var rockerright = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	if(serviceable==1){
		if(x==0){
			#traitement des popup
			var popup_status = getprop("/instrumentation/garmin196/popup_status");
			if(popup_status==10){
				setprop("/instrumentation/garmin196/popup_status",20);
				setprop("/instrumentation/garmin196/dto_display/ligne_select","");
				init_dto_display();
				display_dto_recent();
				return;
			}
			if(popup_status==11){
				var x_char = getprop("/instrumentation/garmin196/dto_display/x_char");
				if(x_char<20){
					setprop("/instrumentation/garmin196/dto_display/x_char",x_char+1);
					display_dto_search();
				}
				return;
			}
			if(popup_status==20){
				setprop("/instrumentation/garmin196/popup_status",30);
				return;
			}
			if(popup_status==30){
				setprop("/instrumentation/garmin196/popup_status",10);
				setprop("/instrumentation/garmin196/dto_display/ligne_select","Press Enter to search");
				init_dto_display();
				setprop("/instrumentation/garmin196/dto_display/x_char",0);
				setprop("/instrumentation/garmin196/dto_display/y_char",0);
				return;
			}
			
			if(popup_status==40){
				setprop("/instrumentation/garmin196/popup_status",50);
				display_nrst("vor");
				return;
			}
			
			if(popup_status==50){
				setprop("/instrumentation/garmin196/popup_status",60);
				display_nrst("ndb");
				return;
			}
			
			if(popup_status==60){
				setprop("/instrumentation/garmin196/popup_status",70);
				display_nrst("fix");
				return;
			}
			
			if(popup_status==70){
				setprop("/instrumentation/garmin196/popup_status",80);
				display_nrst("wpt");
				return;
			}
			
			if(popup_status==80){
				setprop("/instrumentation/garmin196/popup_status",90);
				display_nrst("user");
				return;
			}
			
			if(popup_status==90){
				setprop("/instrumentation/garmin196/popup_status",40);
				display_nrst("airport");
				return;
			}
			
			var status = getprop("/instrumentation/garmin196/status");
			
			if(status==110){
				if(getprop("/instrumentation/garmin196/menu_flights/max_ligne_selected")>=0){
					setprop("/instrumentation/garmin196/menu_flights/no_ligne_selected",0);
					setprop("/instrumentation/garmin196/status",111);
				}
				return;
			}
				
			##menu aircraft
			if(status==140){
				setprop("/instrumentation/garmin196/status",141);
				setprop("/instrumentation/garmin196/menu_aircraft/no_ligne_selected",getprop("/instrumentation/garmin196/no_aircraft"));
				display_list_aircraft();
				return;
			}
			
			if(status==141){
				setprop("/instrumentation/garmin196/status",142);
				init_menu_aircraft();
				return;
			}
			
			if(status==142){
				var x_char = getprop("/instrumentation/garmin196/menu_aircraft/x_char");
				if(x_char<20){
					setprop("/instrumentation/garmin196/menu_aircraft/x_char",x_char+1);
					display_menu_aircraft_name();
				}
				return;
			}
			
			##menu map
			if(status==160){
				setprop("/instrumentation/garmin196/status",161);
				setprop("/instrumentation/garmin196/menu_map/no_ligne_selected",0);
				return;
			}
			
			##menu setup
			if(status==170){
				setprop("/instrumentation/garmin196/status",171);
				setprop("/instrumentation/garmin196/menu_setup/no_ligne_selected",0);
				return;
			}
		}
	}
}

##recalc speed to display
var change_speed_display = func{
	var max_speed = getprop("/instrumentation/garmin196/max-speed");
	var speed = getprop("/instrumentation/gps/indicated-ground-speed-kt");
	setprop("/instrumentation/garmin196/speed-display",315*speed/max_speed);
}

##calcul du turn rate
var calcul_turn_rate = func(dt){
	if(last_bearing==-1){
		last_bearing = getprop("/instrumentation/gps/magnetic-bug-error-deg");
	}
	bearing = getprop("/instrumentation/gps/magnetic-bug-error-deg");
	
	var turn_rate = abs(bearing - last_bearing);
	if(turn_rate>180){
		turn_rate = 360 - turn_rate;
 	}
	var sgn = 1;
	if(bearing - last_bearing<0){
		sgn = -1;
	}
	turn_rate = turn_rate/dt;
	if(turn_rate<10){##pour enlever les valeurs aberentes
		props.globals.getNode("/instrumentation/garmin196/turn-rate",1).setDoubleValue(sgn*turn_rate);
	}
	last_bearing = bearing;
}

var change_wpt_id = func{
	if(getprop("/instrument/gps/mode")!=nil and getprop("/autopilot/route-manager/wp[0]/id")!=""){
		props.global.getNode("/instrumentation/garmin196/panel-wpt-id").alias("/autopilot/route-manager/wp[0]/id");
	}else{
		setprop("/instrumentation/garmin196/panel-wpt-id",getprop("/instrumentation/garmin196/panel-wpt-dto-id"));
	}
}
setlistener("/instrumentation/gps/mode",change_wpt_id);

var change_position_wpt_bug = func{
	var wpt_bearing = getprop("/instrumentation/gps/wp/wp[1]/bearing-mag-deg");
	var aircraft_bearing = getprop("/instrumentation/gps/indicated-track-magnetic-deg");
	
	var diff = wpt_bearing - aircraft_bearing;
	setprop("/instrumentation/garmin196/position-wpt-bearing",diff);
	setprop("/instrumentation/garmin196/panel-wpt-bearing",diff);
}

var update_map = func{
	##protection, une seule recherche gps a la fois, la popup devient prioritaire
	var popup_status = getprop("/instrumentation/garmin196/popup_status");
	if(popup_status<10 or popup_status>99){
		var max_plots = 25;
		var offset_mul = 0.034;
		var symbol_map_range = getprop("/instrumentation/garmin196/map-range") * 8;
		var plots = [];
		var type_symbol = [ "airport" , "vor" , "ndb" , "fix" , "twn" , "wpt"];
		
		for(var i=0;i<size(type_symbol);i=i+1){
			if(getprop("/instrumentation/garmin196/symbols/params/"~type_symbol[i])==1){
				if(type_symbol[i]=="twn" or type_symbol[i]=="wpt"){
					props.globals.getNode("/instrumentation/gps/scratch/max-results", 1).setIntValue(max_plots*2 + 1);
				}else{
					props.globals.getNode("/instrumentation/gps/scratch/max-results", 1).setIntValue(max_plots + 1);
				}
				props.globals.getNode("/instrumentation/gps/scratch/longitude-deg", 1).setDoubleValue(-9999);
				props.globals.getNode("/instrumentation/gps/scratch/latitude-deg", 1).setDoubleValue(-9999);
				var type = type_symbol[i];
				if(type == "twn"){
					type = "wpt";
				}
				setprop("/instrumentation/gps/scratch/type", type);
				setprop("/instrumentation/gps/command", "nearest");
				
				while (getprop('/instrumentation/gps/scratch/has-next')) {
					var id = getprop('/instrumentation/gps/scratch/ident');
					var range = getprop('/instrumentation/gps/scratch/distance-nm') / symbol_map_range; 
					var bearing = 360 - getprop("/instrumentation/gps/indicated-track-magnetic-deg") + getprop('/instrumentation/gps/scratch/mag-bearing-deg');
					#var bearing = 360 - getprop("/orientation/heading-deg") + getprop('/instrumentation/gps/scratch/mag-bearing-deg');
					if(bearing<0){
						bearing = bearing + 360;
					}
					
					if(bearing>360){
						bearing = bearing - 360;
					}
					
					if(i==1){##vor
						id = id ~ " " ~ sprintf("%2.2f",getprop('/instrumentation/gps/scratch/frequency-mhz'));
					}
					
					if(i==2){##ndb
						id = id ~ " " ~ sprintf("%2.1f",getprop('/instrumentation/gps/scratch/frequency-khz'));
					}
					
					var plot = { id: id,bearing: bearing,type: i,range: range};
					if(range<=1){
						if(i<4){
							append(plots,plot);
						}elsif(i==4 and substr(id,size(id)-6)=="WPTTWN"){
							append(plots,plot);
						}elsif(i==5 and substr(id,size(id)-6)=="WPTUSR"){
							append(plots,plot);
						}
					}else{
						break;
					}
					setprop("/instrumentation/gps/command", "next");
				}
			}
		}

		var plots_sorted = sort (plots, func (a,b) a.range - b.range);
		var nb_plots = max_plots;
		if(nb_plots>size(plots_sorted)){
			nb_plots = size(plots_sorted);
		}
		for(var i=0;i<nb_plots;i=i+1){
			if(plots_sorted[i].type==4 or plots_sorted[i].type==5){##town or waypoint
				var type_wpt = substr(plots_sorted[i].id,size(plots_sorted[i].id)-6);
				if(type_wpt=="WPTTWN"){#cities
					plots_sorted[i].id = substr(plots_sorted[i].id,0,size(plots_sorted[i].id)-8);
				}elsif(type_wpt=="WPTUSR"){#wpt user
					plots_sorted[i].id = substr(plots_sorted[i].id,0,size(plots_sorted[i].id)-6);##peut etre a recalculer
					plots_sorted[i].type = 5;
				}
			}
			
			props.globals.getNode("/instrumentation/garmin196/symbols/symbol["~i~"]/id",1).setValue(plots_sorted[i].id);
			props.globals.getNode("/instrumentation/garmin196/symbols/symbol["~i~"]/type",1).setValue(plots_sorted[i].type);
			
			##calcul des coordonnees
			var x_wp = math.cos(plots_sorted[i].bearing*math.pi/180) * plots_sorted[i].range * offset_mul;
			var y_wp = math.sin(plots_sorted[i].bearing*math.pi/180) * plots_sorted[i].range * offset_mul;
			props.globals.getNode("/instrumentation/garmin196/symbols/symbol["~i~"]/x",1).setDoubleValue(x_wp);
			props.globals.getNode("/instrumentation/garmin196/symbols/symbol["~i~"]/y",1).setDoubleValue(y_wp);
			props.globals.getNode("/instrumentation/garmin196/symbols/symbol["~i~"]/brg_offset",1).setDoubleValue(plots_sorted[i].bearing);
			props.globals.getNode("/instrumentation/garmin196/symbols/symbol["~i~"]/norm_dist",1).setDoubleValue(plots_sorted[i].range);
			#
			if(x_wp<0.026 and x_wp>-0.026 and y_wp<0.0323 and y_wp>-0.0323){##si on est dans l'ecran, on affiche
				props.globals.getNode("/instrumentation/garmin196/symbols/symbol["~i~"]/visible",1).setBoolValue(1);
			}else{
				props.globals.getNode("/instrumentation/garmin196/symbols/symbol["~i~"]/visible",1).setBoolValue(0);
			}
		}

		for(var i=nb_plots;i<max_plots;i=i+1){
			props.globals.getNode("/instrumentation/garmin196/symbols/symbol["~i~"]/visible",1).setIntValue(0);
		}
	}
	if(getprop("/instrumentation/garmin196/serviceable")==1 and getprop("/instrumentation/garmin196/status")==10){
		settimer(update_map,1);
	}
}

var display_dto_recent = func{
	var waypoints = props.globals.getNode("/instrumentation/garmin196/waypoints/recent/",1);
	var i = 0;
	foreach (var e; waypoints.getChildren("wpt")) {
		var id = e.getChild("id").getValue();
		var type = e.getChild("type").getValue();
		var ligne = id;
		if(type=="wpt"){
			var type_wpt = substr(id,size(id)-6);
			if(type_wpt=="WPTTWN"){#cities
				ligne = substr(id,0,size(id)-8);
				ligne = substr(ligne,0,15);
			}elsif(type_wpt=="WPTUSR"){#wpt user
				ligne = substr(id,0,size(id)-6);##peut etre a recalculer
			}
		}
		
		ligne = ligne ~ " " ~ type;
		var ligne_spaces = "                              ";
		ligne_spaces = substr(ligne_spaces,0,15-size(ligne));
		
		props.globals.getNode("/instrumentation/gps/scratch/max-results", 1).setIntValue(1);
		props.globals.getNode("/instrumentation/gps/scratch/longitude-deg", 1).setDoubleValue(-9999);
		props.globals.getNode("/instrumentation/gps/scratch/latitude-deg", 1).setDoubleValue(-9999);
		setprop("/instrumentation/gps/scratch/type", type);
		setprop("/instrumentation/gps/scratch/query", id);
		setprop("/instrumentation/gps/command", "search");
		
		var range = getprop("/instrumentation/gps/scratch/distance-nm");
		var	bearing = getprop("/instrumentation/gps/scratch/mag-bearing-deg");
		
		ligne = ligne ~ ligne_spaces ~ sprintf(" %03.f",bearing);
		if(getprop("/instrumentation/garmin196/params/units/distance")==1){
			ligne = ligne ~sprintf(" %3.1fnm",range);
		}else{
			ligne = ligne ~sprintf(" %3.1fkm",range*1.852);
		}
		
		if(i==0){
			setprop("/instrumentation/garmin196/dto_display/ligne_select",ligne);
			props.globals.getNode("/instrumentation/garmin196/dto_display/ligne["~i~"]/selected",1).setBoolValue(1);
		}else{
			props.globals.getNode("/instrumentation/garmin196/dto_display/ligne["~i~"]/selected",1).setBoolValue(0);
		}
		setprop("/instrumentation/garmin196/dto_display/ligne["~i~"]/texte",ligne);
		setprop("/instrumentation/garmin196/dto_display/ligne["~i~"]/id",id);
		setprop("/instrumentation/garmin196/dto_display/ligne["~i~"]/type",type);
		i=i+1;
	}
	for(var j=i;j<5;j=j+1){
		setprop("/instrumentation/garmin196/dto_display/ligne["~j~"]/texte","");
		props.globals.getNode("/instrumentation/garmin196/dto_display/ligne["~j~"]/selected",1).setBoolValue(0);
		setprop("/instrumentation/garmin196/dto_display/ligne["~j~"]/id","");
		setprop("/instrumentation/garmin196/dto_display/ligne["~j~"]/type","");
	}
	setprop("/instrumentation/garmin196/dto_display/no_ligne_selected",0);
	setprop("/instrumentation/garmin196/dto_display/max_ligne_selected",i-1);
	if(i==0){
		setprop("/instrumentation/garmin196/dto_display/ligne_select","");
	}
}

var affectation_waypoint = func(id){
	setprop("/autopilot/route-manager/input","@CLEAR");
	setprop("/autopilot/route-manager/input","@insert0:"~id);
	setprop("/autopilot/route-manager/input","@JUMP0");
	setprop("/autopilot/route-manager/input","@ACTIVATE");
}

var display_dto_search = func{
	var ligne_selected = getprop("/instrumentation/garmin196/dto_display/ligne_select");
	var x_char = props.globals.getNode("/instrumentation/garmin196/dto_display/x_char").getValue();
	ligne_selected = substr(ligne_selected,0,x_char);
	ligne_selected = ligne_selected ~ tab_chiffres_lettres[getprop("/instrumentation/garmin196/dto_display/y_char")];
	setprop("/instrumentation/garmin196/dto_display/ligne_select",ligne_selected);

	##recherche gps
	props.globals.getNode("/instrumentation/gps/scratch/max-results", 1).setIntValue(5);
	props.globals.getNode("/instrumentation/gps/scratch/longitude-deg", 1).setDoubleValue(-9999);
	props.globals.getNode("/instrumentation/gps/scratch/latitude-deg", 1).setDoubleValue(-9999);
	props.globals.getNode("/instrumentation/gps/scratch/exact", 1).setBoolValue(0);
	props.globals.getNode("/instrumentation/gps/scratch/query",1).setValue(ligne_selected);
	
	setprop("/instrumentation/gps/command", "search");
	var i=0;
	var flag_continue = getprop("/instrumentation/gps/scratch/valid");
	while (flag_continue and i<5) {
		var id = getprop('/instrumentation/gps/scratch/ident');
		var range = getprop('/instrumentation/gps/scratch/distance-nm');
		var bearing = getprop('/instrumentation/gps/scratch/mag-bearing-deg');
		var type = getprop('/instrumentation/gps/scratch/type');
		
		var ligne = id;
		if(type=="waypoint"){
			type = "wpt";
			var type_wpt = substr(id,size(id)-6);
			if(type_wpt=="WPTTWN"){#cities
				ligne = substr(id,0,size(id)-8);
			}elsif(type_wpt=="WPTUSR"){#wpt user
				ligne = substr(id,0,size(id)-6);##peut etre a recalculer
			}
		}
		
		ligne = ligne ~ " " ~ type;
		var ligne_spaces = "                              ";
		ligne_spaces = substr(ligne_spaces,0,16-size(ligne));
		
		ligne = ligne ~ ligne_spaces ~ sprintf(" %03.f",bearing);
		if(getprop("/instrumentation/garmin196/params/units/distance")==1){
			ligne = ligne ~sprintf("  %3.1fnm",range);
		}else{
			ligne = ligne ~sprintf("  %3.1fkm",range*1.852);
		}
		var popup_status = getprop("/instrumentation/garmin196/popup_status");
		if(i==0 and popup_status!=10 and popup_status!=11){
			props.globals.getNode("/instrumentation/garmin196/dto_display/ligne["~i~"]/selected",1).setBoolValue(1);
		}else{
			props.globals.getNode("/instrumentation/garmin196/dto_display/ligne["~i~"]/selected",1).setBoolValue(0);
		}
		setprop("/instrumentation/garmin196/dto_display/ligne["~i~"]/texte",ligne);
		setprop("/instrumentation/garmin196/dto_display/ligne["~i~"]/id",id);
		setprop("/instrumentation/garmin196/dto_display/ligne["~i~"]/type",type);
		
		setprop("/instrumentation/garmin196/dto_display/no_ligne_selected",0);
		setprop("/instrumentation/garmin196/dto_display/max_ligne_selected",i-1);
		
		i=i+1;
		setprop("/instrumentation/gps/command", "next");
		flag_continue = getprop("/instrumentation/gps/scratch/has-next");
	}

	for(var j=i;j<5;j=j+1){
		setprop("/instrumentation/garmin196/dto_display/ligne["~j~"]/texte","");
		props.globals.getNode("/instrumentation/garmin196/dto_display/ligne["~j~"]/selected",1).setBoolValue(0);
		setprop("/instrumentation/garmin196/dto_display/ligne["~j~"]/id","");
		setprop("/instrumentation/garmin196/dto_display/ligne["~j~"]/type","");
	}
	setprop("/instrumentation/garmin196/dto_display/no_ligne_selected",0);
	setprop("/instrumentation/garmin196/dto_display/max_ligne_selected",i-1);
}

var searchLastChar = func(chaine, char){
	var result = -1;
	var char_a_tester = substr(chaine,char,1);
	for(var i=0;i<size(tab_chiffres_lettres);i=i+1){
		if(tab_chiffres_lettres[i]==char_a_tester){
			result = i;
			break;
		}
	}
	return result;
}

var init_dto_display = func{
	for(var i=0;i<5;i=i+1){
		setprop("/instrumentation/garmin196/dto_display/ligne["~i~"]/texte","");
		props.globals.getNode("/instrumentation/garmin196/dto_display/ligne["~i~"]/selected",1).setBoolValue(0);
		setprop("/instrumentation/garmin196/dto_display/ligne["~i~"]/id","");
		setprop("/instrumentation/garmin196/dto_display/ligne["~i~"]/type","");
	}
}

var init_nrst_display = func{
	for(var i=0;i<5;i=i+1){
		setprop("/instrumentation/garmin196/nrst_display/ligne["~i~"]/texte","");
		props.globals.getNode("/instrumentation/garmin196/nrst_display/ligne["~i~"]/selected",1).setBoolValue(0);
		setprop("/instrumentation/garmin196/nrst_display/ligne["~i~"]/id","");
		setprop("/instrumentation/garmin196/nrst_display/ligne["~i~"]/type","");
	}
}

var display_nrst = func(type){
	if(type=="user"){
		for(var i=0;i<5;i=i+1){
			setprop("/instrumentation/garmin196/nrst_display/ligne["~i~"]/texte","");
			props.globals.getNode("/instrumentation/garmin196/nrst_display/ligne["~i~"]/selected",1).setBoolValue(0);
			setprop("/instrumentation/garmin196/nrst_display/ligne["~i~"]/id","");
			setprop("/instrumentation/garmin196/nrst_display/ligne["~i~"]/type","");
		}
		setprop("/instrumentation/garmin196/nrst_display/no_ligne_selected",0);
		setprop("/instrumentation/garmin196/nrst_display/max_ligne_selected",0);
		setprop("/instrumentation/garmin196/nrst_display/ligne_select","No User point defined...");
	}elsif(type=="wpt"){
		props.globals.getNode("/instrumentation/gps/scratch/max-results", 1).setIntValue(25);
		props.globals.getNode("/instrumentation/gps/scratch/longitude-deg", 1).setDoubleValue(-9999);
		props.globals.getNode("/instrumentation/gps/scratch/latitude-deg", 1).setDoubleValue(-9999);
		#props.globals.getNode("/instrumentation/gps/scratch/exact", 1).setBoolValue(1);
		props.globals.getNode("/instrumentation/gps/scratch/type",1).setValue(type);
		setprop("/instrumentation/gps/command", "nearest");
		var i=0;
		var flag_continue = getprop("/instrumentation/gps/scratch/valid");
		while (flag_continue and i<5) {
			var id = getprop("/instrumentation/gps/scratch/ident");
			var range = getprop("/instrumentation/gps/scratch/distance-nm");
			var	bearing = getprop("/instrumentation/gps/scratch/mag-bearing-deg");

			var type_wpt = substr(id,size(id)-6);
			if(type_wpt=="WPTTWN"){
				var ligne = substr(id,0,size(id)-8);
				ligne = substr(ligne,0,18);
				var ligne_spaces = "                              ";
				ligne_spaces = substr(ligne_spaces,0,18-size(ligne));
				ligne = ligne ~ ligne_spaces ~ sprintf(" %03.f",bearing);
				if(getprop("/instrumentation/garmin196/params/units/distance")==1){
					ligne = ligne ~sprintf(" %3.1fnm",range);
				}else{
					ligne = ligne ~sprintf(" %3.1fkm",range*1.852);
				}
				
				if(i==0){
					setprop("/instrumentation/garmin196/nrst_display/ligne_select",ligne);
					props.globals.getNode("/instrumentation/garmin196/nrst_display/ligne["~i~"]/selected",1).setBoolValue(1);
				}else{
					props.globals.getNode("/instrumentation/garmin196/nrst_display/ligne["~i~"]/selected",1).setBoolValue(0);
				}
				setprop("/instrumentation/garmin196/nrst_display/ligne["~i~"]/texte",ligne);
				setprop("/instrumentation/garmin196/nrst_display/ligne["~i~"]/id",id);
				setprop("/instrumentation/garmin196/nrst_display/ligne["~i~"]/type",type);
				i=i+1;
			}
			setprop("/instrumentation/gps/command", "next");
			flag_continue = getprop("/instrumentation/gps/scratch/has-next");
		}
		setprop("/instrumentation/garmin196/nrst_display/no_ligne_selected",0);
		setprop("/instrumentation/garmin196/nrst_display/max_ligne_selected",(i-1));
				
	}else{
		props.globals.getNode("/instrumentation/gps/scratch/max-results", 1).setIntValue(6);
		props.globals.getNode("/instrumentation/gps/scratch/longitude-deg", 1).setDoubleValue(-9999);
		props.globals.getNode("/instrumentation/gps/scratch/latitude-deg", 1).setDoubleValue(-9999);
		#props.globals.getNode("/instrumentation/gps/scratch/exact", 1).setBoolValue(1);
		props.globals.getNode("/instrumentation/gps/scratch/type",1).setValue(type);
		setprop("/instrumentation/gps/command", "nearest");
		var i=0;
		var flag_continue = getprop("/instrumentation/gps/scratch/valid");
		while (flag_continue and i<5) {
			var id = getprop("/instrumentation/gps/scratch/ident");
			var ligne = id;
			var range = getprop("/instrumentation/gps/scratch/distance-nm");
			var	bearing = getprop("/instrumentation/gps/scratch/mag-bearing-deg");
			var ligne_spaces = "                              ";
			ligne_spaces = substr(ligne_spaces,0,6-size(ligne));
			ligne = ligne ~ ligne_spaces ~ sprintf(" %03.f",bearing);
			if(getprop("/instrumentation/garmin196/params/units/distance")==1){
				ligne = ligne ~sprintf(" %3.1fnm",range);
			}else{
				ligne = ligne ~sprintf(" %3.1fkm",range*1.852);
			}
			if(type=="airport"){
				var runways = props.globals.getNode("/instrumentation/gps/scratch",1);
				var max_length = 0;
				foreach (var e; runways.getChildren("runways")) {
					var runway_length = e.getChild("length-ft").getValue();
					if(runway_length>max_length){
						max_length = runway_length;
					}
				}
				if(getprop("/instrumentation/garmin196/params/units/distance")==1){
					ligne = ligne ~ " " ~ sprintf("%4.0fft",max_length);
				}else{
					ligne = ligne ~ " " ~ sprintf("%4.0fm",max_length*0.3048);
				}
				
				var radio = getprop("/instrumentation/garmin196/airports_atis/id_"~id);
				if(radio!=nil){
					ligne = ligne ~ sprintf(" %3.2f",radio);
				}
			}elsif(type=="vor"){
				ligne = ligne ~ " " ~ sprintf("%2.2f",getprop('/instrumentation/gps/scratch/frequency-mhz'));
			}elsif(type=="ndb"){
				ligne = ligne ~ " " ~ sprintf("%2.1f",getprop('/instrumentation/gps/scratch/frequency-khz'));
			}
			if(i==0){
				setprop("/instrumentation/garmin196/nrst_display/ligne_select",ligne);
				props.globals.getNode("/instrumentation/garmin196/nrst_display/ligne["~i~"]/selected",1).setBoolValue(1);
			}else{
				props.globals.getNode("/instrumentation/garmin196/nrst_display/ligne["~i~"]/selected",1).setBoolValue(0);
			}
			setprop("/instrumentation/garmin196/nrst_display/ligne["~i~"]/texte",ligne);
			setprop("/instrumentation/garmin196/nrst_display/ligne["~i~"]/id",id);
			setprop("/instrumentation/garmin196/nrst_display/ligne["~i~"]/type",type);
			i=i+1;
			
			setprop("/instrumentation/gps/command", "next");
			flag_continue = getprop("/instrumentation/gps/scratch/has-next");
		}
		setprop("/instrumentation/garmin196/nrst_display/no_ligne_selected",0);
		setprop("/instrumentation/garmin196/nrst_display/max_ligne_selected",(i-1));
	}
}

var load_cities = func{
	print("Garmin 196 loading cities");
	fgcommand("loadxml", props.Node.new({ filename: getprop("/sim/fg-root")~"/Aircraft/Instruments-3d/garmin196/cities.xml", targetnode: "/instrumentation/garmin196/cities" }));
	var waypoints = props.globals.getNode("/instrumentation/garmin196/cities/waypoints",1);
	foreach (var e; waypoints.getChildren("waypoint")) {
		var id = e.getChild("id").getValue();
		var latitude = e.getChild("latitude").getValue();
		var longitude = e.getChild("longitude").getValue();
		
		props.globals.getNode("/instrumentation/gps/scratch/longitude-deg", 1).setDoubleValue(longitude);
		props.globals.getNode("/instrumentation/gps/scratch/latitude-deg", 1).setDoubleValue(latitude);
		props.globals.getNode("/instrumentation/gps/scratch/ident",1).setValue(id);
		setprop("/instrumentation/gps/command","define-user-wpt");
	}
	props.globals.getNode("/instrumentation/garmin196").removeChildren("cities");
	
	
	print("Garmin 196 loading cities done");
}

var update_wp_id_display=func{
	var id=getprop("/autopilot/route-manager/wp[0]/id");
	if(size(id)>6){
		var type_wpt=substr(id,size(id)-6);
		if(type_wpt=="WPTTWN"){#cities
			id=substr(id,0,size(id)-8);
			id=substr(id,0,13);
		}elsif(type_wpt=="WPTUSR"){#wpt user
			id=substr(id,0,size(id)-6);
		}
	}
	setprop("/instrumentation/garmin196/panel-wpt-id",id);
}
setlistener("/autopilot/route-manager/wp[0]/id",update_wp_id_display);

var display_list_aircraft = func{
	var no_ligne = getprop("/instrumentation/garmin196/menu_aircraft/no_ligne_selected");
	var max_speed = getprop("/instrumentation/garmin196/params/aircrafts/aircraft["~no_ligne~"]/max-speed");
	var name = getprop("/instrumentation/garmin196/params/aircrafts/aircraft["~no_ligne~"]/name");
	setprop("/instrumentation/garmin196/max-speed",max_speed);
	setprop("/instrumentation/garmin196/no_aircraft",no_ligne);
	
	var aircraft_display = name ~ "    vmax=";
	if(getprop("/instrumentation/garmin196/params/units/speed")==1){
		aircraft_display = aircraft_display ~ max_speed ~"kt";
	}else{
		aircraft_display = aircraft_display ~ sprintf("%3.0f",(max_speed*1.852)) ~"km/h";
	}
	setprop("/instrumentation/garmin196/menu_aircraft/text",aircraft_display);
}

var init_menu_aircraft = func{
	var no_ligne = getprop("/instrumentation/garmin196/menu_aircraft/no_ligne_selected");
	
	setprop("/instrumentation/garmin196/menu_aircraft/selected-name",getprop("/instrumentation/garmin196/params/aircrafts/aircraft["~no_ligne~"]/name"));
	setprop("/instrumentation/garmin196/menu_aircraft/selected-max",getprop("/instrumentation/garmin196/params/aircrafts/aircraft["~no_ligne~"]/max-speed"));
	setprop("/instrumentation/garmin196/menu_aircraft/selected-cruise",getprop("/instrumentation/garmin196/params/aircrafts/aircraft["~no_ligne~"]/cruise-speed"));
	setprop("/instrumentation/garmin196/menu_aircraft/selected-fuelflow",getprop("/instrumentation/garmin196/params/aircrafts/aircraft["~no_ligne~"]/fuel-flow"));
					
	setprop("/instrumentation/garmin196/menu_aircraft/x_char",size(getprop("/instrumentation/garmin196/menu_aircraft/selected-name"))-1);
	setprop("/instrumentation/garmin196/menu_aircraft/y_char",searchLastChar(getprop("/instrumentation/garmin196/menu_aircraft/selected-name"),getprop("/instrumentation/garmin196/menu_aircraft/x_char")));
	display_menu_aircraft();
}

var validate_menu_aircraft=func{
	var no_ligne = getprop("/instrumentation/garmin196/menu_aircraft/no_ligne_selected");
	
	setprop("/instrumentation/garmin196/params/aircrafts/aircraft["~no_ligne~"]/name",getprop("/instrumentation/garmin196/menu_aircraft/selected-name"));
	setprop("/instrumentation/garmin196/params/aircrafts/aircraft["~no_ligne~"]/max-speed",getprop("/instrumentation/garmin196/menu_aircraft/selected-max"));
	setprop("/instrumentation/garmin196/params/aircrafts/aircraft["~no_ligne~"]/cruise-speed",getprop("/instrumentation/garmin196/menu_aircraft/selected-cruise"));
	setprop("/instrumentation/garmin196/params/aircrafts/aircraft["~no_ligne~"]/fuel-flow",getprop("/instrumentation/garmin196/menu_aircraft/selected-fuelflow"));
	save_parameters();
}

var display_menu_aircraft=func{
	if(getprop("/instrumentation/garmin196/params/units/speed")==1){
		setprop("/instrumentation/garmin196/menu_aircraft/selected-max-display",getprop("/instrumentation/garmin196/menu_aircraft/selected-max")~"kt");
		setprop("/instrumentation/garmin196/menu_aircraft/selected-cruise-display",getprop("/instrumentation/garmin196/menu_aircraft/selected-cruise")~"kt");
	}else{
		setprop("/instrumentation/garmin196/menu_aircraft/selected-max-display",sprintf("%3.0fkm/h",getprop("/instrumentation/garmin196/menu_aircraft/selected-max")*1.852));
		setprop("/instrumentation/garmin196/menu_aircraft/selected-cruise-display",sprintf("%3.0fkm/h",getprop("/instrumentation/garmin196/menu_aircraft/selected-cruise")*1.852));
	}
}

var display_menu_aircraft_name = func{
	var ligne_selected = getprop("/instrumentation/garmin196/menu_aircraft/selected-name");
	var x_char = props.globals.getNode("/instrumentation/garmin196/menu_aircraft/x_char").getValue();
	ligne_selected = substr(ligne_selected,0,x_char);
	ligne_selected = ligne_selected ~ tab_chiffres_lettres[getprop("/instrumentation/garmin196/menu_aircraft/y_char")];
	setprop("/instrumentation/garmin196/menu_aircraft/selected-name",ligne_selected);
}

var display_menu_flights = func{
	var flights = props.globals.getNode("/instrumentation/garmin196/flights",1);
	var i = 0;
	foreach (var e; flights.getChildren("flight")) {
		var start = e.getChild("start").getValue();
		var end = e.getChild("end").getValue();
		var date = e.getChild("date").getValue();
		var aircraft = e.getChild("aircraft").getValue();
		var distance = e.getChild("distance").getValue();
		var duration = e.getChild("duration").getValue();
		
		if(getprop("/instrumentation/garmin196/params/units/distance")==1){
			distance = sprintf("%03.1fnm",distance);
		}else{
			distance = sprintf("%03.1fkm",distance*1.852);
		}
		var ligne = sprintf("%s to %s    %s",start,end,date);
		
		setprop("/instrumentation/garmin196/menu_flights/ligne["~i~"]/texte",ligne);
		setprop("/instrumentation/garmin196/menu_flights/ligne["~i~"]/start",start);
		setprop("/instrumentation/garmin196/menu_flights/ligne["~i~"]/end",end);
		setprop("/instrumentation/garmin196/menu_flights/ligne["~i~"]/date",date);
		setprop("/instrumentation/garmin196/menu_flights/ligne["~i~"]/aircraft",aircraft);
		setprop("/instrumentation/garmin196/menu_flights/ligne["~i~"]/distance",distance);
		setprop("/instrumentation/garmin196/menu_flights/ligne["~i~"]/duration",sprintf("%03.1fh",duration));
		
		i=i+1;
	}
	for(var j=i;j<8;j=j+1){
		setprop("/instrumentation/garmin196/menu_flights/ligne["~j~"]/texte","");
	}
	setprop("/instrumentation/garmin196/menu_flights/max_ligne_selected",i-1);
}

var update_menu_flights_detail = func{
	var no_ligne = getprop("/instrumentation/garmin196/menu_flights/no_ligne_selected");
	setprop("/instrumentation/garmin196/menu_flights/ligne_selected/texte",getprop("/instrumentation/garmin196/menu_flights/ligne["~no_ligne~"]/start")~" to "~getprop("/instrumentation/garmin196/menu_flights/ligne["~no_ligne~"]/end"));
	setprop("/instrumentation/garmin196/menu_flights/ligne_selected/date",getprop("/instrumentation/garmin196/menu_flights/ligne["~no_ligne~"]/date"));
	setprop("/instrumentation/garmin196/menu_flights/ligne_selected/aircraft",getprop("/instrumentation/garmin196/menu_flights/ligne["~no_ligne~"]/aircraft"));
	setprop("/instrumentation/garmin196/menu_flights/ligne_selected/distance",getprop("/instrumentation/garmin196/menu_flights/ligne["~no_ligne~"]/distance"));
	setprop("/instrumentation/garmin196/menu_flights/ligne_selected/duration",getprop("/instrumentation/garmin196/menu_flights/ligne["~no_ligne~"]/duration"));
}

var update_flight = func{
	if(getprop("/instrumentation/garmin196/flight/inflight")==nil){
		props.globals.getNode("/instrumentation/garmin196/flight/inflight",1).setBoolValue(0);
		props.globals.getNode("/instrumentation/garmin196/flight/start",1).setValue("");
	}

	var inflight = getprop("/instrumentation/garmin196/flight/inflight");
	var speed = getprop("/instrumentation/gps/indicated-ground-speed-kt");
	if(inflight==1){
		if(speed<30){#speed<30kt, flight saved
			
			props.globals.getNode("/instrumentation/gps/scratch/max-results", 1).setIntValue(1);
			props.globals.getNode("/instrumentation/gps/scratch/longitude-deg", 1).setDoubleValue(-9999);
			props.globals.getNode("/instrumentation/gps/scratch/latitude-deg", 1).setDoubleValue(-9999);
			props.globals.getNode("/instrumentation/gps/scratch/type",1).setValue("airport");
			setprop("/instrumentation/gps/command", "nearest");
			var id = getprop("/instrumentation/gps/scratch/ident");
			props.globals.getNode("/instrumentation/garmin196/flight/end",1).setValue(id);
			props.globals.getNode("/instrumentation/garmin196/flight/distance",1).setDoubleValue(getprop("/instrumentation/gps/trip-odometer"));
			props.globals.getNode("/instrumentation/garmin196/flight/duration",1).setDoubleValue((getprop("/sim/time/elapsed-sec")-getprop("/instrumentation/garmin196/flight/start-time"))/3600);
			setprop("/instrumentation/garmin196/flight/inflight",0);
			
			##inscription dans le carnet de vol
			for(var i=7;i>0;i=i-1){
				if(getprop("/instrumentation/garmin196/flights/flight["~(i-1)~"]/start")!=nil){
					props.globals.getNode("/instrumentation/garmin196/flights/flight["~i~"]/start",1).setValue(getprop("/instrumentation/garmin196/flights/flight["~(i-1)~"]/start"));
					props.globals.getNode("/instrumentation/garmin196/flights/flight["~i~"]/end",1).setValue(getprop("/instrumentation/garmin196/flights/flight["~(i-1)~"]/end"));
					props.globals.getNode("/instrumentation/garmin196/flights/flight["~i~"]/date",1).setValue(getprop("/instrumentation/garmin196/flights/flight["~(i-1)~"]/date"));
					props.globals.getNode("/instrumentation/garmin196/flights/flight["~i~"]/aircraft",1).setValue(getprop("/instrumentation/garmin196/flights/flight["~(i-1)~"]/aircraft"));
					props.globals.getNode("/instrumentation/garmin196/flights/flight["~i~"]/distance",1).setDoubleValue(getprop("/instrumentation/garmin196/flights/flight["~(i-1)~"]/distance"));
					props.globals.getNode("/instrumentation/garmin196/flights/flight["~i~"]/duration",1).setDoubleValue(getprop("/instrumentation/garmin196/flights/flight["~(i-1)~"]/duration"));
				}
			}
			props.globals.getNode("/instrumentation/garmin196/flights/flight[0]/start",1).setValue(getprop("/instrumentation/garmin196/flight/start"));
			props.globals.getNode("/instrumentation/garmin196/flights/flight[0]/end",1).setValue(getprop("/instrumentation/garmin196/flight/end"));
			props.globals.getNode("/instrumentation/garmin196/flights/flight[0]/date",1).setValue(getprop("/instrumentation/garmin196/flight/date"));
			props.globals.getNode("/instrumentation/garmin196/flights/flight[0]/aircraft",1).setValue(getprop("/instrumentation/garmin196/flight/aircraft"));
			props.globals.getNode("/instrumentation/garmin196/flights/flight[0]/distance",1).setDoubleValue(getprop("/instrumentation/garmin196/flight/distance"));
			props.globals.getNode("/instrumentation/garmin196/flights/flight[0]/duration",1).setDoubleValue(getprop("/instrumentation/garmin196/flight/duration"));
			display_menu_flights();
			save_parameters();
		}
	}else{
		if(speed>30){#speed>30kt, flight started
			props.globals.getNode("/instrumentation/gps/scratch/max-results", 1).setIntValue(1);
			props.globals.getNode("/instrumentation/gps/scratch/longitude-deg", 1).setDoubleValue(-9999);
			props.globals.getNode("/instrumentation/gps/scratch/latitude-deg", 1).setDoubleValue(-9999);
			props.globals.getNode("/instrumentation/gps/scratch/type",1).setValue("airport");
			setprop("/instrumentation/gps/command", "nearest");
			var id = getprop("/instrumentation/gps/scratch/ident");
			props.globals.getNode("/instrumentation/garmin196/flight/start",1).setValue(id);
			var no_aircraft = getprop("/instrumentation/garmin196/no_aircraft");
			var aircraft = getprop("/instrumentation/garmin196/params/aircrafts/aircraft["~no_aircraft~"]/name");
			props.globals.getNode("/instrumentation/garmin196/flight/aircraft",1).setValue(aircraft);
			props.globals.getNode("/instrumentation/garmin196/flight/date",1).setValue(substr(getprop("/sim/time/gmt"),0,10));
			props.globals.getNode("/instrumentation/garmin196/flight/start-time",1).setDoubleValue(getprop("/sim/time/elapsed-sec"));
			setprop("/instrumentation/gps/trip-odometer",0);
			setprop("/instrumentation/garmin196/flight/inflight",1);
		}
	}
}

var update_e6b_menu=func{
	var status = getprop("/instrumentation/garmin196/status");
	if(status==150){
		if(getprop("/instrumentation/garmin196/params/units/pressure")==1){
			setprop("/instrumentation/garmin196/menu_e6b/baro-pressure",sprintf("%2.2fInHg",getprop("/environment/pressure-sea-level-inhg")));
		}else{
			setprop("/instrumentation/garmin196/menu_e6b/baro-pressure",sprintf("%4.0fhPa",getprop("/environment/pressure-sea-level-inhg")/0.03));
		}
		
		var diff_speed = getprop("/instrumentation/gps/indicated-ground-speed-kt") - getprop("/velocities/airspeed-kt");
		if(getprop("/instrumentation/garmin196/params/units/speed")==1){
			setprop("/instrumentation/garmin196/menu_e6b/wind-speed",sprintf("%1.0fkt",getprop("/environment/wind-speed-kt")));
			setprop("/instrumentation/garmin196/menu_e6b/calibrated-airspeed",sprintf("%1.0fkt",getprop("/instrumentation/gps/indicated-ground-speed-kt")));
			setprop("/instrumentation/garmin196/menu_e6b/true-airspeed",sprintf("%1.0fkt",getprop("/velocities/airspeed-kt")));
			setprop("/instrumentation/garmin196/menu_e6b/head-wind",sprintf("%1.0fkt",diff_speed));
		}else{
			setprop("/instrumentation/garmin196/menu_e6b/wind-speed",sprintf("%1.0fkm/h",getprop("/environment/wind-speed-kt")*1.852));
			setprop("/instrumentation/garmin196/menu_e6b/calibrated-airspeed",sprintf("%1.0fkm/h",getprop("/instrumentation/gps/indicated-ground-speed-kt")*1.852));
			setprop("/instrumentation/garmin196/menu_e6b/true-airspeed",sprintf("%1.0fkm/h",getprop("/velocities/airspeed-kt")*1.852));
			setprop("/instrumentation/garmin196/menu_e6b/head-wind",sprintf("%1.0fkm/h",diff_speed*1.852));
		}
		
		if(getprop("/instrumentation/garmin196/params/units/altitude")==1){
			setprop("/instrumentation/garmin196/menu_e6b/indicated-altitude",sprintf("%1.0fft",getprop("/instrumentation/gps/indicated-altitude-ft")));
			setprop("/instrumentation/garmin196/menu_e6b/density-altitude",sprintf("%1.0fft",getprop("/position/altitude-ft")));
		}else{
			setprop("/instrumentation/garmin196/menu_e6b/indicated-altitude",sprintf("%1.0fm",getprop("/instrumentation/gps/indicated-altitude-ft")*0.1097));
			setprop("/instrumentation/garmin196/menu_e6b/density-altitude",sprintf("%1.0fm",getprop("/position/altitude-ft")*0.1097));
		}

		if(getprop("/instrumentation/garmin196/params/units/temperature")==1){
			setprop("/instrumentation/garmin196/menu_e6b/air-temp",sprintf("%1.1fC",getprop("/environment/temperature-degc")));
		}else{
			setprop("/instrumentation/garmin196/menu_e6b/air-temp",sprintf("%1.1fF",getprop("/environment/temperature-degf")));
		}
		setprop("/instrumentation/garmin196/menu_e6b/wind-from",sprintf("%1.0f",getprop("/environment/wind-from-heading-deg")));
		setprop("/instrumentation/garmin196/menu_e6b/heading",sprintf("%1.0f",getprop("/orientation/heading-deg")));
	}
}